<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/../lib/PageGlobal.php';
	require_once $twatch->path( 'lib/AdminPage.php' );
	
	$twatch->makeParentClass( 'AdminCommentsPage', 'TwatchAdminPage' );
	
	class AdminCommentsPage extends AdminCommentsPageParent {
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase;
			
			require_once $twatch->path( 'lib/Comments.php' );
			
			$this->title = 'Admin: Comments';
			$this->toRoot = '..';
		
			$this->init();

			$this->inHead->pl( '<script type="text/javascript" src="../js/AdminComments.js"></script>' );
			
			$this->selected_left_button = 13;
			
			$this->open( $p );
			
			$minYear = 2004;
			$maxYear = $twatch->now->getYear();
			$year = $twatch->now->getYear();
			$month = $twatch->now->getMonth();
			$day = $twatch->now->getDay();
			
			$comments = new TwatchComments();
			
			$p->pl( '<h1>Comments</h1>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/', 1 );
			$this->initJsPage( $p );
			$p->rel();
			$p->pl( '	comments = new Comments( '.$minYear.', '.$maxYear.', '.$year.', '.$month.', '.$day.' );' );
			$p->pl( '	comments.insert();' );
			$p->pl( '	comments.area.element.focus();' );
			$p->hold( 1 );
			foreach( $comments->getAll() as $comment ) {
				$p->pl( 'comments.addItem( '.$comment->adminJsObject().' );' );
			}
			$p->rel();
			$p->pl( '/*]]>*/</script>' );
			
			$this->close( $p );
		}
	}
	
	$twatch->applyOverrides( array( 'AdminCommentsPage' => true ) );
	
	$page = $twatch->makeObject( 'AdminCommentsPage' );
	$page->render( $p );
?>