<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/../lib/PageGlobal.php';
	require_once $twatch->path( 'lib/AdminPage.php' );
	
	$twatch->makeParentClass( 'AdminEntitiesPage', 'TwatchAdminPage' );
	
	class AdminEntitiesPage extends AdminEntitiesPageParent {
		
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase;
			
			$this->title = 'Admin: Entities';
			$this->toRoot = '..';
			
			$this->init();
			
			$this->inHead->pl( '<script type="text/javascript" src="../js/Entity.js"></script>' );
			
			$this->selected_left_button = 6;
			
			$this->open( $p );
			
			$entities = &$twatch->config->getList( TwatchConfig::ENTITIES );
			
			$p->pl( '<h1>Entities</h1>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/', 1 );
			$this->initJsPage( $p );
			$p->rel();
			$p->pl( '	entitiesHolder = new EntitiesHolder();' );
			$p->pl( '	entitiesHolder.insert();', 0 );
			foreach( $entities as $entity ) {
				$p->pl( 'entitiesHolder.addItem( '.$entity->jsObject().' );' );
			}
			$p->pl( '/*]]>*/</script>' );
			
			$this->close( $p );
		}
	}
	
	$twatch->applyOverrides( array( 'AdminEntitiesPage' => true ) );
	
	$page = $twatch->makeObject( 'AdminEntitiesPage' );
	$page->render( $p );
?>