<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	
	require_once dirname(__FILE__).'/../lib/PageGlobal.php';
	require_once $twatch->path( 'lib/AdminPage.php' );
	
	$twatch->makeParentClass( 'AdminIndexPage', 'TwatchAdminPage' );
	
	class AdminIndexPage extends AdminIndexPageParent {
		
		protected function includeBaseJs() {
			global $twatch;
			parent::includeBaseJs();
			$this->inHead->pl( '<script type="text/javascript" src="'.$twatch->baseUrl( $this->toRoot, 'js/ArdeExpression.js' ).'"></script>' );
		}
		
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase, $ardeUser;
			
			require_once $twatch->path( 'lib/TimeZone.php' );
	
			$this->toRoot = '..';
			
			$this->title = 'Administrate';
			
			$this->init();
			
			$this->inHead->pl( '<script type="text/javascript" src="'.$twatch->url( $this->toRoot, 'js/TwatchDiag.js' ).'"></script>' );
			$this->inHead->pl( '<script type="text/javascript" src="'.$twatch->url( $this->toRoot, 'js/UserManager.js' ).'"></script>' );
			$this->inHead->pl( '<script type="text/javascript" src="'.$twatch->url( $this->toRoot, 'js/Logger.js' ).'"></script>' );
			
			$this->selected_left_button = 0;
			
			$this->open( $p );
			
			require $twatch->path( 'lib/TwatchDiag.php' );
			require_once $twatch->path( 'lib/EntityV.php' );
			
			require_once $twatch->extPath( 'user', 'lib/Global.php' );
			require_once $ardeUser->path( 'lib/User.php' );
			require_once $twatch->path( 'data/DataUsers.php' );
			
			
			
			
			
			$this->printContents( $p );
			
			
			$this->close( $p );
		}
		
		protected function printContents( ArdePrinter $p ) {
			global $twatch, $ardeBase, $ardeUser;
			
			$userData = new TwatchUserData( ArdeUser::USER_PUBLIC );
			$userData->addDefaults( TwatchUserData::$defaultProperties );
			$userData->loadChanges();
			
			$perms = new ArdeAppender( ', ' );
			
			$perms->append( ArdeJs::bool( $userData->get( TwatchUserData::VIEW_REPORTS ) ) );
			$perms->append( ArdeJs::bool( $userData->get( TwatchUserData::VIEW_ADMIN ) ) );
			$perms->append( ArdeJs::bool( $userData->get( TwatchUserData::ADMINISTRATE ) ) );
			$perms->append( ArdeJs::bool( $userData->get( TwatchUserData::VIEW_IPS ) ) );
			$perms->append( ArdeJs::bool( $userData->get( TwatchUserData::VIEW_COOKIE_IDS ) ) );
			
			$diag = new TwatchDiag();
			$diag->load(); 
			
			$p->pl ('<h2>Users</h2>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/', 1 );
			$this->initJsPage( $p );
			$p->rel();
			$p->pl( '	userManager = new UserManager( '.$perms->s.' );' );
			$p->pl( '	userManager.insert();' );
			$p->pl( '/*]]>*/</script>' );
			
			$p->pl( '<h2>Language</h2>' );
			$p->pl( '<div class="block"><p>' );
			$p->pl( 'Default Language: <select id="def_lang_select">' );

			$defaultId = $twatch->config->get( TwatchConfig::DEFAULT_LANG );

			foreach( $twatch->getLocaleIds() as $id ) {
				$p->pl( '<option value="'.$id.'"'.($id == $defaultId?' selected="true"':'').'>'.$id.'</option>' );
			}
			$p->pl( '</select>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			$p->pl( "	defLangSelect = document.getElementById( 'def_lang_select' );" );
			$p->pl( "	langUpdateButton = new ArdeRequestButton( 'Update' );" );
			$p->pl( '	langUpdateButton.insert();' );
			$p->pl( '	langUpdateButton.onclick = function() {' );
			$p->pl( "		langUpdateButton.request( twatchFullUrl( 'rec/rec_general.php' ), 'a=update_def_lang&i='+defLangSelect.options[ defLangSelect.selectedIndex ].value );" );
			$p->pl( '	};' );
			$p->pl( '/*]]>*/</script>' );
			$p->pl( '</p></div>' );
			$p->pl( '<h2>Time Zone</h2>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			
			$tz =  TwatchTimeZone::fromConfig();
			
			$p->pl( '	timeZone = '.$tz->jsObject().';' );
			$p->pl( '	timeZone.insert();' );
			$p->pl( '/*]]>*/</script>' );
			
			$p->pl( '<h2>Logger</h2>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			$p->hold(1);
			TwatchExpression::printJsInputElements( $p );
			$p->rel();
			$expression = new TwatchExpression( $twatch->config->get( TwatchConfig::LOGGER_WHEN ), null );
			$p->pl( '	logger = new Logger( '.$expression->jsObject().' );' );
			$p->pl( '	logger.insert();' );
			$p->pl( '/*]]>*/</script>' );

			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			$p->pl( '	diag = '.$diag->jsObject().';' );
			$p->pl( '	diag.insert();' );
			$p->pl( '/*]]>*/</script>' );
			$p->pl( '<hr />' );
			$p->pl( '<p>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			$p->pl( "	upgradeKeysButton = new ArdeRequestButton( 'Upgrade Tracking Cookie Keys', 'This will invalidate any tracking cookie you already have in visitors\' browser' ).setCritical( true );" );
			$p->pl( '	upgradeKeysButton.insert();' );
			$p->pl( '	upgradeKeysButton.onclick = function() {' );
			$p->pl( "		upgradeKeysButton.request( twatchFullUrl( 'rec/rec_general.php' ), 'a=upgrade_cookie_keys' );" );
			$p->pl( '	};' );
			$p->pl( '/*]]>*/</script>' );
			$p->pl( '</p>' );
			$p->pl( '<hr />' );
			if( $ardeUser->user->hasPermission( TwatchUserData::ADMINISTRATE ) ) {
				if( isset( $_SERVER[ 'SERVER_SOFTWARE' ] ) ) {
					$serverName = $_SERVER[ 'SERVER_SOFTWARE' ].' - '.php_sapi_name();
				} else {
					$serverName = "UNKNOWN";
				}
				try {
					$version = $twatch->config->get( TwatchConfig::VERSION );
				} catch( Exception $e ) {
					$version = '%ERROR%';
				}
				$p->pl( '<p><b>PHP</b> version: <span class="fixed">'.phpversion().'</span></p>' );
				$p->pl( '<p><b>MySql</b> server version: <span class="fixed">'.mysql_get_server_info().'</span></p>' );
				$p->pl( '<p><b>HTTP</b> server: <span class="fixed">'.$serverName.'</span></p>' );
				$p->pl( '<p><b>Database data</b> version: <span class="fixed">'.$version.'</span>' );
			}
		}
	} 
	
	$twatch->applyOverrides( array( 'AdminIndexPage' => true ) );
	
	$page = $twatch->makeObject( 'AdminIndexPage' );
	
	$page->render( $p );

	
?>
