<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
	
	global $ardeBase, $ardeBaseProfile, $twatch, $twatchProfile;
	
	if( !isset( $twatchProfile ) ) $twatchProfile = 'default';
	
	if( !file_exists( dirname(__FILE__).'/../profiles/'.$twatchProfile ) ) {
		echo "profile '".$twatchProfile."' doesn't exist, using default.";
		$twatchProfile = 'default';
	}
	
	if( !isset( $ardeBase ) ) {
		$twatchSettings = twatchGetSettings( $twatchProfile );
		$ardeBaseProfile = $twatchSettings[ 'base_profile' ];
		require_once dirname(__FILE__).'/../'.$twatchSettings[ 'to_base' ].'/lib/Global.php';
	}
	
	function twatchGetSettings( $profile ) {
		$settings = array();
		include dirname(__FILE__).'/../profiles/'.$profile.'/settings.php';
		return $settings;
	}
	
	class TwatchApp extends ArdeAppWithPlugins {
		
		var $version = "0.332";
		
		var $name = 'twatch';
		
		var $now;
		
		var $db;
		
		var $config;
		
		var $state;
		
		protected function getPluginClassName() {
			return 'TwatchPlugin';
		}
		
		public static function initUser() {
			global $ardeBase, $ardeUser, $twatch, $ardeUserProfile;
			$ardeUserProfile = $twatch->settings[ 'user_profile' ];
			require_once $twatch->extPath( 'user', 'lib/Global.php' );
			require_once $ardeUser->path( 'lib/User.php' );
			require_once $twatch->path( 'data/DataUsers.php' );
			$ardeUser->db = new ArdeDb( $ardeUser->settings );
			$ardeUser->db->connect();
			$ardeUser->user = ArdeUser::getUser();
			$ardeUser->user->data = new TwatchUserData( $ardeUser->user->id );
			$ardeUser->user->data->addDefaults( TwatchUserData::$defaultProperties );
			$ardeUser->user->data->loadChanges();
		}
		
		public function path( $target ) {
			return ardeSlashConcat( dirname(__FILE__).'/..', $target );
		}
		
		public function extPath( $appName, $target ) {
			return ardeSlashConcat( dirname(__FILE__).'/..', $this->settings[ 'to_'.$appName ], $target );
		}
		
		
	}
	
	function twatchConnect() {
		global $twatch;
		if( !isset( $twatch->db ) ) {
			$twatch->db = new ArdeDb( $twatch->settings );
			$twatch->db->connect();
		}
	}
	
	class TwatchPlugin extends ArdePlugin {
		
		public $startId;
		
		public function getLayer() {
			return $this->id;
		}
		
		public function getStartId() { return $this->startId; }
		
		public function applyConfigChanges( TwatchConfig $config, $ids ) {}
		
		public function applyStateChanges( TwatchState $state, $ids ) {}
		
		public function afterTwatchInstall( ArdePrinter $p ) {}
	}
	
	$twatch = new TwatchApp( $ardeBase );
	$twatch->loadSettings( $twatchProfile );
	$twatch->loadPlugins();
	
	
?>