<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	
	ini_set( 'display_errors', '1' );

	if( isset( $_GET[ 'profile' ] ) ) {
		$twatchProfile = $_GET[ 'profile' ];
	}

	
	require_once dirname(__FILE__).'/../lib/Global.php';
	
	if( $twatch->settings[ 'down' ] ) die( $twatch->settings[ 'down_message' ] );
	
	require_once $ardeBase->path( 'lib/ArdeXmlPrinter.php' );
	require_once $ardeBase->path( 'lib/ArdeJs.php' );
	
	require_once $twatch->path( 'data/DataGlobal.php' );
	
	$xhtml = isset( $_GET['xhtml'] );
	
	$p = new ArdeXmlPrinter( $xhtml, !$xhtml, 'response' );
	ArdeException::startErrorSystem( $p, $p );
	
	$p->setHideErrors( !$twatch->settings[ 'unauthorized_show_errors' ] );
	$p->setMutedErrors( $twatch->settings[ 'unauthorized_muted_errors' ] );

	
	$p->start( 'application' );
	
	if( $xhtml ) {
		$p->pl( '<body>', 1 );
	}
	
	foreach( $_GET as $k => $v ) { $_POST[$k] = $v; }
	
	$twatch->db = new ArdeDb( $twatch->settings );
	$twatch->db->connect();
	
	TwatchApp::initUser();
	
	if( $ardeUser->user->hasPermission( TwatchUserData::VIEW_ERRORS ) ) {
		$p->setMutedErrors(  $twatch->settings[ 'authorized_muted_errors' ] );
		$p->setHideErrors( !$twatch->settings[ 'authorized_show_errors' ] );
	}
	
	if( ( $twatch->settings[ 'authorized_log_errors' ] && $ardeUser->user->hasPermission( TwatchUserData::VIEW_ERRORS ) ) ||
		( $twatch->settings[ 'unauthorized_log_errors' ] && !$ardeUser->user->hasPermission( TwatchUserData::VIEW_ERRORS ) ) ) {
		ArdeException::setGlobalReporter( new TwatchErrorLogger( ArdeException::getGlobalReporter() ) );
	}
	
	if( !$ardeUser->user->hasPermission( TwatchUserData::VIEW_REPORTS ) || ( isset( $adminConfig ) && !$ardeUser->user->hasPermission( TwatchUserData::ADMINISTRATE ) ) ) {
		throw new TwatchUserError( "You don't have permission" );
	}	

	
	
	$twatch->config = new TwatchConfig( $twatch->db );
	$twatch->state = new TwatchState( $twatch->db );
	$twatch->config->addDefaults( TwatchConfig::$defaultProperties );
	$twatch->state->addDefaults( TwatchState::$defaultProperties );
	$twatch->state->addDefaults( TwatchState::$extraDefaults );
	
	function loadConfig( $extraDefConfig = array() ) {
		global $twatch;
		foreach( $extraDefConfig as $extraDef ) {
			$twatch->config->addDefaults( $extraDef );
		}
		$twatch->config->applyAllChanges();
		$twatch->state->applyAllChanges();
		
		$twatch->callFunction( 'twatchSetAppTime' );
		
		if( isset( $_GET[ 'lang' ] ) && $twatch->localeExists( $_GET[ 'lang' ] ) ) {
			$twatch->loadLocale( $_GET[ 'lang' ] );
		} else {
			$twatch->loadLocale( $twatch->config->get( TwatchConfig::DEFAULT_LANG ) );
		}
	}

	
	
?>